/*
** variable.hh
** Login : <nico@Altarion.marmotte.ath.cx>
** Started on  Tue Dec  3 21:25:02 2002 Nicolas
** $Id: variable.hh,v 1.1 2002/12/09 11:26:50 speedblue Exp $
** 
** Copyright (C) 2002 Nicolas
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#ifndef   	VARIABLE_HH_
# define   	VARIABLE_HH_

#include &lt;iostream&gt;
#include &lt;string&gt;

namespace Data
{
  class Variable
  {
   public:
    Variable() :
      _name(\"\"), _val(0)
    {}

    const std::string&	get_name() const {return _name; }
    std::string&	get_name() {return _name; }
    void		set_name(const std::string& name) {_name = name; }

    const int&		get_val() const {return _val; }
    int&		get_val() {return _val; }
    void		set_val(const int& val) {_val = val; }

    const std::vector&lt;int&gt;&	get_subvars() const 
    { return _subvars; }

    std::vector&lt;int&gt;&		get_subvars() { return _subvars; }
    const int&		get_subvars(const int pos) const 
    { return _subvars[pos]; }

    int&		get_subvars(const int pos) { return _subvars[pos]; }
    void		set_subvars(const std::vector&lt;int&gt;& subvars) 
    { _subvars = subvars; }

    void		add_subvars(const int& subvars) 
    { _subvars.push_back(subvars); }

   protected:
    std::string		_name;
    int			_val;
    std::vector&lt;int&gt;	_subvars;

   public:
     void print(std::ostream&s const)
       {
	 s << _name << ' ' << _val << std::endl;
	 for (unsigned int i = 0; i < _subvars.size(); i++)
	   s << _subvars[i] << ' ';
	 s << std::endl;
       }

  };

  //Code outside classe declaration
  inline std::ostream& operator<<(std::ostream& s, const Variable& v)
  {
    v.print(s);
    return s;
  }
}

#endif	    /* !VARIABLE_HH_ */
